#include "format.h"

using format::FormatString;
using format::FormatDict;

struct P2d
{
    int x, y;
    P2d(int x, int y)
        : x(x), y(y)
    {
    }
};

namespace format {
    template<>
    std::string toString<P2d>(const P2d& p, const std::string& parms)
    {
        return FormatString("P2d(%+020>*/2,4:{x}; %011X,2:{y})") % FormatDict()
            ("x", p.x)
            ("y", p.y);
    }
}

#include <iostream>

int main()
{
    FormatString fs("p=%{p}");
    FormatDict fd;
    fd("p", P2d(1234, 0xbadf00d));
    std::cout << fs % fd << std::endl;
    return 0;
}
